import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// Find the midpoint of a hyperbolic circle

//dot(O,red);

hyperbolic_point C = hyperbolic_point(1,60);
hyperbolic_point P = hyperbolic_point(0.5,90);

hyperbolic_segment S = hyperbolic_segment(C,P);
draw(S, blue);
dot(C, black);
dot(P, blue);

hyperbolic_circle circ = hyperbolic_circle(C,P);
fill(circ, blue+opacity(0.3));
draw(circ, blue);

// Arbitrary line that intersects the circle
hyperbolic_point O = hyperbolic_point(1,0);
hyperbolic_point Q = hyperbolic_point(2,55);
hyperbolic_line L = hyperbolic_line(O,Q);

hyperbolic_point[] I = intersection(circ, L);
draw(L, orange);
dot(I, gray);

hyperbolic_point M = midpoint(I[0],I[1]);
hyperbolic_line ML = midline(I[0], I[1]);
draw(ML, orange);
dot(M, gray);

hyperbolic_point[] J = intersection(circ, ML);
dot(J, gray);
hyperbolic_point center = midpoint(J[0],J[1]);
dot(center, orange);

// Write the numerical coordinates to stdout
// The are identical :-)
//write(C.get_euclidean());
//write(center.get_euclidean());

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
